#!/etc/opt/openit/perl -w
#
# Script to fix bad PBS files.
#
# Garbage file name 
#  pbs-1361182823-17802.data
#

BEGIN {
    push @INC, "/opt/openit/contrib/lib";
}

use strict;

use OpeniT::Contrib::Config;

my $config = new OpeniT::Contrib::Config;
$config->read("/etc/opt/openit/openit_contrib.cfg");    # Additional config

my $temp = $config->{TEMP_DIR};
my $garbage = "$temp/garbage";

print "Looking for corrupt PBS in gargabge directory";
print "  ($garbage)\n";

my @files = glob("$garbage/pbs-*");

foreach my $file (@files) {
    my $dest = $file;
    $dest =~ s/^$garbage/$temp/;

    print "Fixing $file (to $dest)\n";
    &fix_file($file, $dest);

    # Removing fixed file
    unlink $file;
}

exit;

sub fix_file {
    my ($input, $output) = @_;

    open(IN, $input) || die "Unable to read '$input'";
    open(OUT, ">$output") || die "Unable to write '$output'";

    my $class;
    while ( defined( $class = <IN> ) ) {
	my $values = <IN>;

	my @classvars = split(":", $class);

	# Identify classification lines with one field too many
	if (scalar(@classvars) == 24) {
	    # merge lines with _ between field 9 and 10 and
	    # : between the rest
	    $class = join(":", @classvars[0..8]) . "_" .
	      join(":", @classvars[9..23]);
	}
	print OUT $class;
	print OUT $values;
    }

    close(OUT);
    close(IN);
}
